Index: kernel/arch/ia64/src/drivers/it.c
===================================================================
--- kernel/arch/ia64/src/drivers/it.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/ia64/src/drivers/it.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -34,5 +34,5 @@
 
 /** Interval Timer driver. */
- 
+
 #include <arch/drivers/it.h>
 #include <arch/interrupt.h>
@@ -45,11 +45,11 @@
 #include <arch.h>
 
-#define IT_SERVICE_CLOCKS	64
+#define IT_SERVICE_CLOCKS  64
 
-#define FREQ_NUMERATOR_SHIFT	32
-#define FREQ_NUMERATOR_MASK	0xffffffff00000000ULL
+#define FREQ_NUMERATOR_SHIFT  32
+#define FREQ_NUMERATOR_MASK   0xffffffff00000000ULL
 
-#define FREQ_DENOMINATOR_SHIFT	0
-#define FREQ_DENOMINATOR_MASK	0xffffffffULL
+#define FREQ_DENOMINATOR_SHIFT  0
+#define FREQ_DENOMINATOR_MASK   0xffffffffULL
 
 uint64_t it_delta;
@@ -63,6 +63,4 @@
 void it_init(void)
 {
-	cr_itv_t itv;
-	
 	if (config.cpu_active == 1) {
 		irq_initialize(&it_irq);
@@ -83,17 +81,19 @@
 	}
 	
-	/* initialize Interval Timer external interrupt vector */
+	/* Initialize Interval Timer external interrupt vector */
+	cr_itv_t itv;
+	
 	itv.value = itv_read();
 	itv.vector = INTERRUPT_TIMER;
 	itv.m = 0;
 	itv_write(itv.value);
-
-	/* set Interval Timer Counter to zero */
+	
+	/* Set Interval Timer Counter to zero */
 	itc_write(0);
 	
-	/* generate first Interval Timer interrupt in IT_DELTA ticks */
+	/* Generate first Interval Timer interrupt in IT_DELTA ticks */
 	itm_write(IT_DELTA);
-
-	/* propagate changes */
+	
+	/* Propagate changes */
 	srlz_d();
 }
@@ -104,4 +104,5 @@
  *
  * @return Always IRQ_ACCEPT.
+ *
  */
 irq_ownership_t it_claim(irq_t *irq)
@@ -113,17 +114,14 @@
 void it_interrupt(irq_t *irq)
 {
-	int64_t c;
-	int64_t m;
-	
 	eoi_write(EOI);
 	
-	m = itm_read();
+	int64_t itm = itm_read();
 	
-	while (1) {
-		c = itc_read();
-		c += IT_SERVICE_CLOCKS;
-
-		m += IT_DELTA;
-		if (m - c < 0)
+	while (true) {
+		int64_t itc = itc_read();
+		itc += IT_SERVICE_CLOCKS;
+		
+		itm += IT_DELTA;
+		if (itm - itc < 0)
 			CPU->missed_clock_ticks++;
 		else
@@ -131,14 +129,14 @@
 	}
 	
-	itm_write(m);
-	srlz_d();				/* propagate changes */
-
+	itm_write(itm);
+	srlz_d();  /* Propagate changes */
+	
 	/*
 	 * We are holding a lock which prevents preemption.
 	 * Release the lock, call clock() and reacquire the lock again.
 	 */
-	spinlock_unlock(&irq->lock);	
+	irq_spinlock_unlock(&irq->lock, false);
 	clock();
-	spinlock_lock(&irq->lock);
+	irq_spinlock_lock(&irq->lock, false);
 }
 
Index: kernel/arch/ia64/src/drivers/ski.c
===================================================================
--- kernel/arch/ia64/src/drivers/ski.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/ia64/src/drivers/ski.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -216,5 +216,5 @@
 		 * self-sufficient.
 		 */
-		sysinfo_set_item_val("fb", NULL, false);
+		sysinfo_set_item_val("fb.kind", NULL, 6);
 		
 		fb_exported = true;
Index: kernel/arch/ia64/src/interrupt.c
===================================================================
--- kernel/arch/ia64/src/interrupt.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/ia64/src/interrupt.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -57,10 +57,11 @@
 #include <putchar.h>
 
-#define VECTORS_64_BUNDLE	20
-#define VECTORS_16_BUNDLE	48
-#define VECTORS_16_BUNDLE_START	0x5000
-#define VECTOR_MAX		0x7f00
-
-#define BUNDLE_SIZE		16
+#define VECTORS_64_BUNDLE        20
+#define VECTORS_16_BUNDLE        48
+#define VECTORS_16_BUNDLE_START  0x5000
+
+#define VECTOR_MAX  0x7f00
+
+#define BUNDLE_SIZE  16
 
 static const char *vector_names_64_bundle[VECTORS_64_BUNDLE] = {
@@ -132,12 +133,6 @@
 }
 
-static void dump_interrupted_context(istate_t *istate)
-{
-	const char *ifa = symtab_fmt_name_lookup(istate->cr_ifa);
-	const char *iipa = symtab_fmt_name_lookup(istate->cr_iipa);
-	const char *iip = symtab_fmt_name_lookup(istate->cr_iip);
-	
-	putchar('\n');
-	printf("Interrupted context dump:\n");
+void istate_decode(istate_t *istate)
+{
 	printf("ar.bsp=%p\tar.bspstore=%p\n", istate->ar_bsp,
 	    istate->ar_bspstore);
@@ -149,8 +144,10 @@
 	    istate->cr_ipsr);
 	
-	printf("cr.iip=%#018llx, #%d\t(%s)\n", istate->cr_iip,
-	    istate->cr_isr.ei, iip);
-	printf("cr.iipa=%#018llx\t(%s)\n", istate->cr_iipa, iipa);
-	printf("cr.ifa=%#018llx\t(%s)\n", istate->cr_ifa, ifa);
+	printf("cr.iip=%#018llx, #%d\t(%s)\n", istate->cr_iip, istate->cr_isr.ei,
+	    symtab_fmt_name_lookup(istate->cr_iip));
+	printf("cr.iipa=%#018llx\t(%s)\n", istate->cr_iipa,
+	    symtab_fmt_name_lookup(istate->cr_iipa));
+	printf("cr.ifa=%#018llx\t(%s)\n", istate->cr_ifa,
+	    symtab_fmt_name_lookup(istate->cr_ifa));
 }
 
@@ -184,7 +181,5 @@
 	
 	fault_if_from_uspace(istate, "General Exception (%s).", desc);
-	
-	dump_interrupted_context(istate);
-	panic("General Exception (%s).", desc);
+	panic_badtrap(istate, vector, "General Exception (%s).", desc);
 }
 
@@ -196,7 +191,6 @@
 	fault_if_from_uspace(istate, "Interruption: %#hx (%s).",
 	    (uint16_t) vector, vector_to_string(vector));
-	dump_interrupted_context(istate);
-	panic("Interruption: %#hx (%s).", (uint16_t) vector,
-	    vector_to_string(vector));
+	panic_badtrap(istate, vector, "Interruption: %#hx (%s).",
+	    (uint16_t) vector, vector_to_string(vector));
 #endif
 }
@@ -218,5 +212,5 @@
 		istate->cr_ipsr.ri++;
 	}
-
+	
 	return syscall_handler(istate->in0, istate->in1, istate->in2,
 	    istate->in3, istate->in4, istate->in5, istate->in6);
@@ -227,23 +221,24 @@
 	fault_if_from_uspace(istate, "Interruption: %#hx (%s).",
 	    (uint16_t) vector, vector_to_string(vector));
-	dump_interrupted_context(istate);
-	panic("Interruption: %#hx (%s).", (uint16_t) vector,
-	    vector_to_string(vector));
+	panic_badtrap(istate, vector, "Interruption: %#hx (%s).",
+	    (uint16_t) vector, vector_to_string(vector));
 }
 
 static void end_of_local_irq(void)
 {
-	asm volatile ("mov cr.eoi=r0;;");
-}
-
+	asm volatile (
+		"mov cr.eoi=r0;;"
+	);
+}
 
 void external_interrupt(uint64_t vector, istate_t *istate)
 {
 	cr_ivr_t ivr;
-	irq_t *irq;
 	
 	ivr.value = ivr_read();
 	srlz_d();
-
+	
+	irq_t *irq;
+	
 	switch (ivr.vector) {
 	case INTERRUPT_SPURIOUS:
@@ -252,5 +247,5 @@
 #endif
 		break;
-
+	
 #ifdef CONFIG_SMP
 	case VECTOR_TLB_SHOOTDOWN_IPI:
@@ -259,10 +254,10 @@
 		break;
 #endif
-
+	
 	case INTERRUPT_TIMER:
 		irq = irq_dispatch_and_lock(ivr.vector);
 		if (irq) {
 			irq->handler(irq);
-			spinlock_unlock(&irq->lock);
+			irq_spinlock_unlock(&irq->lock, false);
 		} else {
 			panic("Unhandled Internal Timer Interrupt (%d).",
@@ -283,5 +278,5 @@
 			if (!irq->preack)
 				end_of_local_irq();
-			spinlock_unlock(&irq->lock);
+			irq_spinlock_unlock(&irq->lock, false);
 		} else {
 			/*
Index: kernel/arch/ia64/src/mm/tlb.c
===================================================================
--- kernel/arch/ia64/src/mm/tlb.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/ia64/src/mm/tlb.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -500,6 +500,5 @@
 		if (as_page_fault(va, PF_ACCESS_EXEC, istate) == AS_PF_FAULT) {
 			fault_if_from_uspace(istate, "Page fault at %p.", va);
-			panic("%s: va=%p, rid=%d, iip=%p.", __func__, va, rid,
-			    istate->cr_iip);
+			panic_memtrap(istate, PF_ACCESS_EXEC, va, NULL);
 		}
 	}
@@ -622,6 +621,5 @@
 		if (as_page_fault(va, PF_ACCESS_READ, istate) == AS_PF_FAULT) {
 			fault_if_from_uspace(istate, "Page fault at %p.", va);
-			panic("%s: va=%p, rid=%d, iip=%p.", __func__, va, rid,
-			    istate->cr_iip);
+			panic_memtrap(istate, PF_ACCESS_UNKNOWN, va, NULL);
 		}
 	}
@@ -671,6 +669,5 @@
 		if (as_page_fault(va, PF_ACCESS_WRITE, istate) == AS_PF_FAULT) {
 			fault_if_from_uspace(istate, "Page fault at %p.", va);
-			panic("%s: va=%p, rid=%d, iip=%p.", __func__, va, rid,
-			    istate->cr_iip);
+			panic_memtrap(istate, PF_ACCESS_WRITE, va, NULL);
 		}
 	}
@@ -708,6 +705,5 @@
 		if (as_page_fault(va, PF_ACCESS_EXEC, istate) == AS_PF_FAULT) {
 			fault_if_from_uspace(istate, "Page fault at %p.", va);
-			panic("%s: va=%p, rid=%d, iip=%p.", __func__, va, rid,
-			    istate->cr_iip);
+			panic_memtrap(istate, PF_ACCESS_EXEC, va, NULL);
 		}
 	}
@@ -745,6 +741,5 @@
 		if (as_page_fault(va, PF_ACCESS_READ, istate) == AS_PF_FAULT) {
 			fault_if_from_uspace(istate, "Page fault at %p.", va);
-			panic("%s: va=%p, rid=%d, iip=%p.", __func__, va, rid,
-			    istate->cr_iip);
+			panic_memtrap(istate, PF_ACCESS_UNKNOWN, va, NULL);
 		}
 	}
@@ -778,6 +773,5 @@
 	if (as_page_fault(va, PF_ACCESS_WRITE, istate) == AS_PF_FAULT) {
 		fault_if_from_uspace(istate, "Page fault at %p.", va);
-		panic("%s: va=%p, rid=%d, iip=%p.", __func__, va, rid,
-		    istate->cr_iip);
+		panic_memtrap(istate, PF_ACCESS_WRITE, va, NULL);
 	}
 	page_table_unlock(AS, true);
@@ -819,5 +813,5 @@
 		if (as_page_fault(va, PF_ACCESS_READ, istate) == AS_PF_FAULT) {
 			fault_if_from_uspace(istate, "Page fault at %p.", va);
-			panic("%s: va=%p, rid=%d.", __func__, va, rid);
+			panic_memtrap(istate, PF_ACCESS_UNKNOWN, va, NULL);
 		}
 	}
Index: kernel/arch/ia64/src/smp/smp.c
===================================================================
--- kernel/arch/ia64/src/smp/smp.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/ia64/src/smp/smp.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -33,130 +33,19 @@
  */
 
-#include <arch.h>
-#include <arch/drivers/ski.h>
-#include <arch/drivers/it.h>
-#include <arch/interrupt.h>
-#include <arch/barrier.h>
-#include <arch/asm.h>
-#include <arch/register.h>
-#include <typedefs.h>
-#include <arch/context.h>
-#include <arch/stack.h>
-#include <arch/mm/page.h>
-#include <mm/as.h>
-#include <config.h>
-#include <userspace.h>
-#include <console/console.h>
-#include <proc/uarg.h>
-#include <syscall/syscall.h>
-#include <ddi/irq.h>
-#include <ddi/device.h>
-#include <arch/bootinfo.h>
 #include <smp/smp.h>
 #include <smp/ipi.h>
-#include <arch/atomic.h>
-#include <panic.h>
-#include <print.h>
 
 #ifdef CONFIG_SMP
 
-extern char cpu_by_id_eid_list[256][256];
-
-static void sapic_init(void)
+void ipi_broadcast_arch(int ipi)
 {
-	bootinfo->sapic = (unative_t *)(PA2KA((unative_t)(bootinfo->sapic)) |
-	    FW_OFFSET);
-}
-
-static void ipi_broadcast_arch_all(int ipi)
-{
-	int id, eid;
-	int myid, myeid;
-	
-	myid = ia64_get_cpu_id();
-	myeid = ia64_get_cpu_eid();
-	
-	for (id = 0; id < 256; id++)
-		for (eid = 0; eid < 256; eid++)
-			if ((id != myid) || (eid != myeid))
-				ipi_send_ipi(id, eid, ipi);
-}
-
-void ipi_broadcast_arch(int ipi )
-{
-	int id, eid;
-	int myid, myeid;
-	
-	myid = ia64_get_cpu_id();
-	myeid = ia64_get_cpu_eid();
-
-	for (id = 0; id < 256; id++)
-		for (eid = 0; eid < 256; eid++)
-			if ((id != myid) || (eid != myeid))
-				if (cpu_by_id_eid_list[id][eid])
-					ipi_send_ipi(id, eid, ipi);
 }
 
 void smp_init(void)
 {
-	if (!bootinfo->hello_configured)
-		return; 
-	
-	/*
-	 * If we have not got system prepared by hello, we are not able to start
-	 * AP's. This means we are running on a simulator.
-	 */
-	
-	sapic_init();
-	ipi_broadcast_arch_all(bootinfo->wakeup_intno);	
-	volatile long long brk;
-        for (brk = 0; brk < 100LL * 1024LL * 1024LL; brk++)
-		;	/* wait a while before CPUs starts */
-
-	config.cpu_count = 0;
-	int id, eid;
-	
-	for (id = 0; id < 256; id++)
-		for (eid = 0; eid < 256; eid++)
-		        if (cpu_by_id_eid_list[id][eid] == 1) {
-		    		config.cpu_count++;
-		    		cpu_by_id_eid_list[id][eid] = 2;
-			}
 }
 
 void kmp(void *arg __attribute__((unused)))
 {
-	int id, eid;
-	int myid, myeid;
-	
-	myid = ia64_get_cpu_id();
-	myeid = ia64_get_cpu_eid();
-
-	for (id = 0; id < 256; id++)
-		for (eid = 0; eid < 256; eid++)
-		        if ((id != myid) || (eid != myeid))
-		        	if (cpu_by_id_eid_list[id][eid] != 0) {
-		    			if (cpu_by_id_eid_list[id][eid] == 1) {
-				    		printf("Found Late CPU ID:%d "
-						    "EDI:%d Not added to "
-						    "system!!!\n", id, eid);
-				    		continue;
-					}
-					cpu_by_id_eid_list[id][eid] = 3;
-					/*
-					 * There may be just one AP being
-					 * initialized at the time. After
-					 * it comes completely up, it is
-					 * supposed to wake us up.
-					 */
-					if (waitq_sleep_timeout(
-					    &ap_completion_wq, 1000000,
-					    SYNCH_FLAGS_NONE) ==
-					    ESYNCH_TIMEOUT) {
-						printf("%s: waiting for cpu "
-						    "ID:%d EID:%d timed out\n",
-						    __FUNCTION__, id, eid);
-					    }
-				}
 }
 
Index: kernel/arch/ia64/src/start.S
===================================================================
--- kernel/arch/ia64/src/start.S	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/ia64/src/start.S	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -47,19 +47,15 @@
 
 stack0:
+
+#
+# Kernel entry point.
+#
+# This is where we are passed control from the boot code.
+# Register contents:
+#
+#	r2	Address of the boot code's bootinfo structure.
+#
 kernel_image_start:
 	.auto
-	
-#ifdef CONFIG_SMP
-	# Identify self(CPU) in OS structures by ID / EID
-	
-	mov r9 = cr64
-	mov r10 = 1
-	movl r12 = 0xffffffff
-	movl r8 = cpu_by_id_eid_list
-	and r8 = r8, r12
-	shr r9 = r9, 16
-	add r8 = r8, r9
-	st1 [r8] = r10
-#endif
 	
 	mov psr.l = r0
@@ -164,13 +160,4 @@
 	bsw.1
 	
-#ifdef CONFIG_SMP
-	# Am I BSP or AP?
-	movl r20 = bsp_started ;;
-	ld8 r20 = [r20] ;;
-	cmp.eq p3, p2 = r20, r0 ;;
-#else
-	cmp.eq p3, p2 = r0, r0 ;;  /* you are BSP */
-#endif  /* CONFIG_SMP */
-	
 	# Initialize register stack
 	mov ar.rsc = r0
@@ -179,18 +166,21 @@
 	loadrs
 	
-	# Initialize memory stack to some sane value
-	movl r12 = stack0 ;;
-	add r12 = -16, r12  /* allocate a scratch area on the stack */
+	#
+	# Initialize memory stack to some sane value and allocate a scratch are
+	# on it.
+	#
+	movl sp = stack0 ;;
+	add sp = -16, sp
 	
 	# Initialize gp (Global Pointer) register
+	movl gp = kernel_image_start
+	
+	#	
+	# Initialize bootinfo on BSP.
+	#
 	movl r20 = (VRN_KERNEL << VRN_SHIFT) ;;
-	or r20 = r20, r1 ;;
-	movl r1 = kernel_image_start
-	
-	/*
-	 * Initialize bootinfo on BSP.
-	 */
-(p3)	addl r21 = @gprel(bootinfo), gp ;;
-(p3)	st8 [r21] = r20
+	or r20 = r20, r2 ;;
+	addl r21 = @gprel(bootinfo), gp ;;
+	st8 [r21] = r20
 	
 	ssm (1 << 19) ;; /* Disable f32 - f127 */
@@ -198,68 +188,7 @@
 	srlz.d ;;
 	
-#ifdef CONFIG_SMP
-(p2)	movl r18 = main_ap ;;
-(p2)	mov b1 = r18 ;;
-(p2)	br.call.sptk.many b0 = b1
-	
-	# Mark that BSP is on
-	
-	mov r20 = 1 ;;
-	movl r21 = bsp_started ;;
-	st8 [r21] = r20 ;;
-#endif
-	
 	br.call.sptk.many b0 = arch_pre_main
-	
-	movl r18 = main_bsp ;;
-	mov b1 = r18 ;;
-	br.call.sptk.many b0 = b1
-
+0:
+	br.call.sptk.many b0 = main_bsp
 0:
 	br 0b
-
-#ifdef CONFIG_SMP
-
-.align 4096
-kernel_image_ap_start:
-	.auto
-	
-	# Identify self(CPU) in OS structures by ID / EID
-	
-	mov r9 = cr64
-	mov r10 = 1
-	movl r12 = 0xffffffff
-	movl r8 = cpu_by_id_eid_list
-	and r8 = r8, r12
-	shr r9 = r9, 16
-	add r8 = r8, r9
-	st1 [r8] = r10
-	
-	# Wait for wakeup synchro signal (#3 in cpu_by_id_eid_list)
-
-kernel_image_ap_start_loop:
-	movl r11 = kernel_image_ap_start_loop
-	and r11 = r11, r12
-	mov b1 = r11
-	
-	ld1 r20 = [r8]
-	movl r21 = 3
-	cmp.eq p2, p3 = r20, r21
-(p3)	br.call.sptk.many b0 = b1
-	
-	movl r11 = kernel_image_start
-	and r11 = r11, r12
-	mov b1 = r11
-	br.call.sptk.many b0 = b1
-
-.align 16
-.global bsp_started
-bsp_started:
-	.space 8
-
-.align 4096
-.global cpu_by_id_eid_list
-cpu_by_id_eid_list:
-	.space 65536
-
-#endif  /* CONFIG_SMP */
Index: kernel/arch/mips32/Makefile.inc
===================================================================
--- kernel/arch/mips32/Makefile.inc	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/mips32/Makefile.inc	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -54,5 +54,4 @@
 	arch/$(KARCH)/src/start.S \
 	arch/$(KARCH)/src/context.S \
-	arch/$(KARCH)/src/panic.S \
 	arch/$(KARCH)/src/mips32.c \
 	arch/$(KARCH)/src/asm.S \
Index: kernel/arch/mips32/include/asm.h
===================================================================
--- kernel/arch/mips32/include/asm.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/mips32/include/asm.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup mips32	
+/** @addtogroup mips32
  * @{
  */
@@ -38,71 +38,77 @@
 #include <typedefs.h>
 #include <config.h>
+#include <trace.h>
 
-
-static inline void cpu_sleep(void)
+NO_TRACE static inline void cpu_sleep(void)
 {
-	/* Most of the simulators do not support */
-/*	asm volatile ("wait"); */
+	/*
+	 * Unfortunatelly most of the simulators do not support
+	 *
+	 * asm volatile (
+	 *     "wait"
+	 * );
+	 *
+	 */
 }
 
 /** Return base address of current stack
- * 
+ *
  * Return the base address of the current stack.
  * The stack is assumed to be STACK_SIZE bytes long.
  * The stack must start on page boundary.
+ *
  */
-static inline uintptr_t get_stack_base(void)
+NO_TRACE static inline uintptr_t get_stack_base(void)
 {
-	uintptr_t v;
+	uintptr_t base;
 	
 	asm volatile (
-		"and %0, $29, %1\n"
-		: "=r" (v)
-		: "r" (~(STACK_SIZE-1))
+		"and %[base], $29, %[mask]\n"
+		: [base] "=r" (base)
+		: [mask] "r" (~(STACK_SIZE - 1))
 	);
 	
-	return v;
+	return base;
 }
 
-extern void cpu_halt(void) __attribute__((noreturn));
-extern void asm_delay_loop(uint32_t t);
-extern void userspace_asm(uintptr_t ustack, uintptr_t uspace_uarg,
-    uintptr_t entry);
-
-extern ipl_t interrupts_disable(void);
-extern ipl_t interrupts_enable(void);
-extern void interrupts_restore(ipl_t ipl);
-extern ipl_t interrupts_read(void);
-extern void asm_delay_loop(uint32_t t);
-
-static inline void pio_write_8(ioport8_t *port, uint8_t v)
+NO_TRACE static inline void pio_write_8(ioport8_t *port, uint8_t v)
 {
-	*port = v;	
+	*port = v;
 }
 
-static inline void pio_write_16(ioport16_t *port, uint16_t v)
+NO_TRACE static inline void pio_write_16(ioport16_t *port, uint16_t v)
 {
-	*port = v;	
+	*port = v;
 }
 
-static inline void pio_write_32(ioport32_t *port, uint32_t v)
+NO_TRACE static inline void pio_write_32(ioport32_t *port, uint32_t v)
 {
-	*port = v;	
+	*port = v;
 }
 
-static inline uint8_t pio_read_8(ioport8_t *port)
+NO_TRACE static inline uint8_t pio_read_8(ioport8_t *port)
 {
 	return *port;
 }
 
-static inline uint16_t pio_read_16(ioport16_t *port)
+NO_TRACE static inline uint16_t pio_read_16(ioport16_t *port)
 {
 	return *port;
 }
 
-static inline uint32_t pio_read_32(ioport32_t *port)
+NO_TRACE static inline uint32_t pio_read_32(ioport32_t *port)
 {
 	return *port;
 }
+
+extern void cpu_halt(void) __attribute__((noreturn));
+extern void asm_delay_loop(uint32_t);
+extern void userspace_asm(uintptr_t, uintptr_t, uintptr_t);
+
+extern ipl_t interrupts_disable(void);
+extern ipl_t interrupts_enable(void);
+extern void interrupts_restore(ipl_t);
+extern ipl_t interrupts_read(void);
+extern bool interrupts_disabled(void);
 
 #endif
Index: kernel/arch/mips32/include/atomic.h
===================================================================
--- kernel/arch/mips32/include/atomic.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/mips32/include/atomic.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -36,4 +36,6 @@
 #define KERN_mips32_ATOMIC_H_
 
+#include <trace.h>
+
 #define atomic_inc(x)  ((void) atomic_add(x, 1))
 #define atomic_dec(x)  ((void) atomic_add(x, -1))
@@ -53,5 +55,6 @@
  *
  */
-static inline atomic_count_t atomic_add(atomic_t *val, atomic_count_t i)
+NO_TRACE static inline atomic_count_t atomic_add(atomic_t *val,
+    atomic_count_t i)
 {
 	atomic_count_t tmp;
@@ -76,5 +79,5 @@
 }
 
-static inline atomic_count_t test_and_set(atomic_t *val)
+NO_TRACE static inline atomic_count_t test_and_set(atomic_t *val)
 {
 	atomic_count_t tmp;
@@ -98,5 +101,5 @@
 }
 
-static inline void atomic_lock_arch(atomic_t *val)
+NO_TRACE static inline void atomic_lock_arch(atomic_t *val)
 {
 	do {
Index: kernel/arch/mips32/include/context_offset.h
===================================================================
--- kernel/arch/mips32/include/context_offset.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/mips32/include/context_offset.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -60,32 +60,4 @@
 # define OFFSET_F30     0x5c
 #endif /* KERNEL */
-
-/* istate_t */
-#define EOFFSET_AT     0x0
-#define EOFFSET_V0     0x4
-#define EOFFSET_V1     0x8
-#define EOFFSET_A0     0xc
-#define EOFFSET_A1     0x10
-#define EOFFSET_A2     0x14
-#define EOFFSET_A3     0x18
-#define EOFFSET_T0     0x1c
-#define EOFFSET_T1     0x20
-#define EOFFSET_T2     0x24
-#define EOFFSET_T3     0x28
-#define EOFFSET_T4     0x2c
-#define EOFFSET_T5     0x30
-#define EOFFSET_T6     0x34
-#define EOFFSET_T7     0x38
-#define EOFFSET_T8     0x3c
-#define EOFFSET_T9     0x40
-#define EOFFSET_GP     0x44
-#define EOFFSET_SP     0x48
-#define EOFFSET_RA     0x4c
-#define EOFFSET_LO     0x50
-#define EOFFSET_HI     0x54
-#define EOFFSET_STATUS 0x58
-#define EOFFSET_EPC    0x5c
-#define EOFFSET_K1     0x60
-#define REGISTER_SPACE 104	/* respect stack alignment */
 
 #ifdef __ASM__
Index: kernel/arch/mips32/include/cycle.h
===================================================================
--- kernel/arch/mips32/include/cycle.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/mips32/include/cycle.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -38,6 +38,7 @@
 #include <arch/cp0.h>
 #include <arch/interrupt.h>
+#include <trace.h>
 
-static inline uint64_t get_cycle(void)
+NO_TRACE static inline uint64_t get_cycle(void)
 {
 	return ((uint64_t) count_hi << 32) + ((uint64_t) cp0_count_read());
Index: kernel/arch/mips32/include/debug.h
===================================================================
--- kernel/arch/mips32/include/debug.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/mips32/include/debug.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -36,14 +36,18 @@
 #define KERN_mips23_DEBUG_H_
 
-/**	simulator enters the trace mode */
-#define ___traceon()	asm volatile ( "\t.word\t0x39\n");
-/** 	simulator leaves the trace mode */
-#define ___traceoff()	asm volatile ( "\t.word\t0x3d\n");
-/** 	register dump */
-#define ___regview()	asm volatile ( "\t.word\t0x37\n");
-/** 	halt the simulator */
-#define ___halt()	asm volatile ( "\t.word\t0x28\n");
-/**     simulator enters interactive mode */
-#define ___intmode()	asm volatile ( "\t.word\t0x29\n");
+/** Enter the simulator trace mode */
+#define ___traceon()  asm volatile ( "\t.word\t0x39\n");
+
+/** Leave the simulator trace mode */
+#define ___traceoff()  asm volatile ( "\t.word\t0x3d\n");
+
+/** Ask the simulator to dump registers */
+#define ___regview()  asm volatile ( "\t.word\t0x37\n");
+
+/** Halt the simulator */
+#define ___halt()  asm volatile ( "\t.word\t0x28\n");
+
+/** Enter the simulator interactive mode */
+#define ___intmode()  asm volatile ( "\t.word\t0x29\n");
 
 #endif
Index: kernel/arch/mips32/include/debugger.h
===================================================================
--- kernel/arch/mips32/include/debugger.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/mips32/include/debugger.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -41,25 +41,35 @@
 #define BKPOINTS_MAX 10
 
-#define BKPOINT_INPROG   (1 << 0)   /**< Breakpoint was shot */
-#define BKPOINT_ONESHOT  (1 << 1)   /**< One-time breakpoint,mandatory for j/b
-				         instructions */
-#define BKPOINT_REINST   (1 << 2)   /**< Breakpoint is set on the next 
-				         instruction, so that it could be
-					 reinstalled on the previous one */
-#define BKPOINT_FUNCCALL (1 << 3)   /**< Call a predefined function */
+/** Breakpoint was shot */
+#define BKPOINT_INPROG  (1 << 0)
+
+/** One-time breakpoint, mandatory for j/b instructions */
+#define BKPOINT_ONESHOT  (1 << 1)
+
+/**
+ * Breakpoint is set on the next instruction, so that it
+ * could be reinstalled on the previous one
+ */
+#define BKPOINT_REINST  (1 << 2)
+
+/** Call a predefined function */
+#define BKPOINT_FUNCCALL  (1 << 3)
+
 
 typedef struct  {
-	uintptr_t address;      /**< Breakpoint address */
-	unative_t instruction; /**< Original instruction */
+	uintptr_t address;          /**< Breakpoint address */
+	unative_t instruction;      /**< Original instruction */
 	unative_t nextinstruction;  /**< Original instruction following break */
-	int flags;        /**< Flags regarding breakpoint */
+	unsigned int flags;         /**< Flags regarding breakpoint */
 	size_t counter;
-	void (*bkfunc)(void *b, istate_t *istate);
+	void (*bkfunc)(void *, istate_t *);
 } bpinfo_t;
 
+extern bpinfo_t breakpoints[BKPOINTS_MAX];
+
+extern bool is_jump(unative_t);
+
 extern void debugger_init(void);
-void debugger_bpoint(istate_t *istate);
-
-extern bpinfo_t breakpoints[BKPOINTS_MAX];
+extern void debugger_bpoint(istate_t *);
 
 #endif
Index: kernel/arch/mips32/include/exception.h
===================================================================
--- kernel/arch/mips32/include/exception.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/mips32/include/exception.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup mips32	
+/** @addtogroup mips32
  * @{
  */
@@ -38,34 +38,39 @@
 #include <typedefs.h>
 #include <arch/cp0.h>
+#include <trace.h>
 
-#define EXC_Int		0
-#define EXC_Mod		1
-#define EXC_TLBL	2
-#define EXC_TLBS	3
-#define EXC_AdEL	4
-#define EXC_AdES	5
-#define EXC_IBE		6
-#define EXC_DBE		7
-#define EXC_Sys		8
-#define EXC_Bp		9
-#define EXC_RI		10
-#define EXC_CpU		11
-#define EXC_Ov		12
-#define EXC_Tr		13
-#define EXC_VCEI	14
-#define EXC_FPE		15
-#define EXC_WATCH	23
-#define EXC_VCED	31
+#define EXC_Int    0
+#define EXC_Mod    1
+#define EXC_TLBL   2
+#define EXC_TLBS   3
+#define EXC_AdEL   4
+#define EXC_AdES   5
+#define EXC_IBE    6
+#define EXC_DBE    7
+#define EXC_Sys    8
+#define EXC_Bp     9
+#define EXC_RI     10
+#define EXC_CpU    11
+#define EXC_Ov     12
+#define EXC_Tr     13
+#define EXC_VCEI   14
+#define EXC_FPE    15
+#define EXC_WATCH  23
+#define EXC_VCED   31
 
 typedef struct istate {
+	/*
+	 * The first seven registers are arranged so that the istate structure
+	 * can be used both for exception handlers and for the syscall handler.
+	 */
+	uint32_t a0;	/* arg1 */
+	uint32_t a1;	/* arg2 */
+	uint32_t a2;	/* arg3 */
+	uint32_t a3;	/* arg4 */
+	uint32_t t0;	/* arg5 */
+	uint32_t t1;	/* arg6 */
+	uint32_t v0;	/* arg7 */
+	uint32_t v1;
 	uint32_t at;
-	uint32_t v0;
-	uint32_t v1;
-	uint32_t a0;
-	uint32_t a1;
-	uint32_t a2;
-	uint32_t a3;
-	uint32_t t0;
-	uint32_t t1;
 	uint32_t t2;
 	uint32_t t3;
@@ -74,19 +79,32 @@
 	uint32_t t6;
 	uint32_t t7;
+	uint32_t s0;
+	uint32_t s1;
+	uint32_t s2;
+	uint32_t s3;
+	uint32_t s4;
+	uint32_t s5;
+	uint32_t s6;
+	uint32_t s7;
 	uint32_t t8;
 	uint32_t t9;
+	uint32_t kt0;
+	uint32_t kt1;	/* We use it as thread-local pointer */
 	uint32_t gp;
 	uint32_t sp;
+	uint32_t s8;
 	uint32_t ra;
 	
 	uint32_t lo;
 	uint32_t hi;
+	
+	uint32_t status;	/* cp0_status */
+	uint32_t epc;		/* cp0_epc */
 
-	uint32_t status; /* cp0_status */
-	uint32_t epc; /* cp0_epc */
-	uint32_t k1; /* We use it as thread-local pointer */
+	uint32_t alignment;	/* to make sizeof(istate_t) a multiple of 8 */
 } istate_t;
 
-static inline void istate_set_retaddr(istate_t *istate, uintptr_t retaddr)
+NO_TRACE static inline void istate_set_retaddr(istate_t *istate,
+    uintptr_t retaddr)
 {
 	istate->epc = retaddr;
@@ -94,15 +112,17 @@
 
 /** Return true if exception happened while in userspace */
-static inline int istate_from_uspace(istate_t *istate)
+NO_TRACE static inline int istate_from_uspace(istate_t *istate)
 {
 	return istate->status & cp0_status_um_bit;
 }
-static inline unative_t istate_get_pc(istate_t *istate)
+
+NO_TRACE static inline unative_t istate_get_pc(istate_t *istate)
 {
 	return istate->epc;
 }
-static inline unative_t istate_get_fp(istate_t *istate)
+
+NO_TRACE static inline unative_t istate_get_fp(istate_t *istate)
 {
-	return 0;	/* FIXME */
+	return istate->sp;
 }
 
Index: kernel/arch/mips32/include/mm/page.h
===================================================================
--- kernel/arch/mips32/include/mm/page.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/mips32/include/mm/page.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -37,4 +37,5 @@
 
 #include <arch/mm/frame.h>
+#include <trace.h>
 
 #define PAGE_WIDTH	FRAME_WIDTH
@@ -155,5 +156,5 @@
 
 
-static inline unsigned int get_pt_flags(pte_t *pt, size_t i)
+NO_TRACE static inline unsigned int get_pt_flags(pte_t *pt, size_t i)
 {
 	pte_t *p = &pt[i];
@@ -168,5 +169,5 @@
 }
 
-static inline void set_pt_flags(pte_t *pt, size_t i, int flags)
+NO_TRACE static inline void set_pt_flags(pte_t *pt, size_t i, int flags)
 {
 	pte_t *p = &pt[i];
Index: kernel/arch/mips32/include/mm/tlb.h
===================================================================
--- kernel/arch/mips32/include/mm/tlb.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/mips32/include/mm/tlb.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -39,4 +39,5 @@
 #include <arch/mm/asid.h>
 #include <arch/exception.h>
+#include <trace.h>
 
 #define TLB_ENTRY_COUNT  48
@@ -126,5 +127,5 @@
  * Probe TLB for Matching Entry.
  */
-static inline void tlbp(void)
+NO_TRACE static inline void tlbp(void)
 {
 	asm volatile ("tlbp\n\t");
@@ -136,5 +137,5 @@
  * Read Indexed TLB Entry.
  */
-static inline void tlbr(void)
+NO_TRACE static inline void tlbr(void)
 {
 	asm volatile ("tlbr\n\t");
@@ -145,5 +146,5 @@
  * Write Indexed TLB Entry.
  */
-static inline void tlbwi(void)
+NO_TRACE static inline void tlbwi(void)
 {
 	asm volatile ("tlbwi\n\t");
@@ -154,5 +155,5 @@
  * Write Random TLB Entry.
  */
-static inline void tlbwr(void)
+NO_TRACE static inline void tlbwr(void)
 {
 	asm volatile ("tlbwr\n\t");
